/* gw.h
 *
 * Copyright (C) 1998-2001 by TAMARIBUCHI, Tsuguhiro
 *
 *   WWW: http://sip.sci.shizuoka.ac.jp/grwin
 *
 */


#define OEMRESOURCE			// for OCR_...

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#if defined(__CYGWIN32__)
#include <sys/time.h>
#include <sys/types.h>
#include <termios.h>
#include <unistd.h>
#else
#include <conio.h>
#endif
#include <math.h>
#include <float.h>
#ifdef _MSC_VER
#include <time.h>
#endif
#include <limits.h>
#include <windows.h>
#include <windowsx.h>

#include "Messages.h"
#include "Globals.h"
#include "GrWinAll.h"

#include "Version.h"
#include "GrWin.h"		// for check
//#include "All.h"		// for check

#define floor5(x)		((int)((x)+0.5))
#define GW_asgn(x, y)	((x)?((*(x)) = (y)):0)

//////////////////////////////////////////////////////////////
// FLOAT:
#define GW_RX (GW_pParams->p.GW_Rx)	// GW_Du*NLDC/WC = LDC/WC
#define GW_RY (GW_pParams->p.GW_Ry)	// GW_Du*NLDC/WC = LDC/WC
#define GW_U1 (GW_pParams->p.GW_u1)	// Left   of the viewport in NLDC
#define GW_V1 (GW_pParams->p.GW_v1)	// Bottom of the viewport in NLDC
#define GW_U2 (GW_pParams->p.GW_u2)	// Right  of the viewport in NLDC
#define GW_V2 (GW_pParams->p.GW_v2)	// Top    of the viewport in NLDC
#define GW_X1 (GW_pParams->p.GW_x1)	// Left   of the viewport in WC
#define GW_Y1 (GW_pParams->p.GW_y1)	// Bottom of the viewport in WC
#define GW_X2 (GW_pParams->p.GW_x2)	// Right  of the viewport in WC
#define GW_Y2 (GW_pParams->p.GW_y2)	// Top    of the viewport in WC
// INT:
#define GW_U0 (GW_pParams->p.GW_u0)	// Left   of the viewport in LDC
#define GW_V0 (GW_pParams->p.GW_v0)	// Bottom of the viewport in LDC
#define GW_DU (GW_pParams->p.GW_Du)	// GW_DU * NLDC = LDC
#define GW_DW (GW_pParams->p.GW_Dw)
#define GW_DH (GW_pParams->p.GW_Dh)
#define GW_OG (GW_pParams->p.GW_Og)	// current object group number
#define GW_CF (GW_pParams->p.GW_Cf)	// foreground color
#define GW_CB (GW_pParams->p.GW_Cb)	// background color
//#define GW_VP (GW_pParams->p.GW_Vp)	// current viewport number
#define GW_PM (GW_pParams->p.GW_Pm)	// WC == LDC if GW_Pm!= 0
#define GW_IN (GW_pParams->p.GW_In)	// 
#define GW_IM (GW_pParams->p.GW_Im)	// 
#define GW_IT (GW_pParams->p.GW_It)	// 
#define GW_IO (GW_pParams->p.GW_Io)	// 
#define GW_IB (GW_pParams->p.GW_Ib)	// 
#define GW_FN (GW_pParams->p.GW_Fn)	// 
#define GW_FO (GW_pParams->p.GW_Fo)	// 

extern int nDOC;				// current doc number
extern char cDOC;				// (char)(nDOC + 0x20)

extern LPVOID		FileMaps[];
extern LPVOID		GrWnd_bFileMap;
extern WndParams*	GW_pParams;
extern LPSTR		GW_pBuffer;
extern INT*			GW_pData;
extern POINT*		GW_pPoints;

#define GW_Buffer(n)	(((WndParams*)(FileMaps[n]))->Work.Buffer)
#define GW_Params(n)	((WndParams*)(FileMaps[n]))
#define GW_Data(n)		(((WndParams*)(FileMaps[n]))->Work.Data)
#define GW_Points(n)	(&(((WndParams*)(FileMaps[n]))->Work.Points[0]))
#define GW_Bytes(n)		(((WndParams*)(FileMaps[n]))->Work.Bytes)
